Loading...
Searching...
No Matches
Dune::SuperLU< M > Class Template Reference
Iterative Solvers Template Library (ISTL)

SuperLu Solver. More...

`#include <dune/istl/superlu.hh>`

Inheritance diagram for Dune::SuperLU< M >:

## Public Types

using | Matrix = M
| The matrix type.
using | matrix_type = M
typedef Dune::SuperLUMatrix< Matrix > | SuperLUMatrix
| The corresponding SuperLU Matrix type.
typedef SuperMatrixInitializer< Matrix > | MatrixInitializer
| Type of an associated initializer class.
using | domain_type = typename Impl::SuperLUVectorChooser<M>::domain_type
| The type of the domain of the solver.
using | range_type = typename Impl::SuperLUVectorChooser<M>::range_type
| The type of the range of the solver.

## Public Member Functions

SolverCategory::Category | category () const override
| Category of the solver (see SolverCategory::Category).
| SuperLU (const Matrix &matrix, bool verbose=false, bool reusevector=true)
| Constructs the SuperLU solver.
| SuperLU (const Matrix &matrix, const ParameterTree &config)
| Constructs the SuperLU solver.
| SuperLU ()
| Empty default constructor.
| ~SuperLU ()
void | apply (domain_type &x, range_type &b, InverseOperatorResult &res) override
| Apply inverse operator,.
void | apply (domain_type &x, range_type &b, double reduction, InverseOperatorResult &res) override
| apply inverse operator, with given convergence criteria.
void | apply (T *x, T *b)
| Apply SuperLu to C arrays.
void | setMatrix (const Matrix &mat)
| Initialize data from given matrix.
SuperLUMatrix::size_type | nnz () const
template<class S>
void | setSubMatrix (const Matrix &mat, const S &rowIndexSet)
void | setVerbosity (bool v)
void | free ()
| free allocated space.
const char * | name ()

## Friends

template<class Mat, class X, class TM, class TD, class T1>
class | SeqOverlappingSchwarz
struct | SeqOverlappingSchwarzAssemblerHelper< SuperLU< Matrix >, true >

## Detailed Description

template<typename M>
class Dune::SuperLU< M >

SuperLu Solver.

Uses the well known SuperLU package to solve the system.

SuperLU supports single and double precision floating point and complex numbers. Unfortunately these cannot be used at the same time. Therefore users must set SUPERLU_NTYPE (0: float, 1: double, 2: std::complex<float>, 3: std::complex<double>) if the numeric type should be different from double.

## Member Typedef Documentation

## domain_type

template<typename M>

using Dune::SuperLU< M >::domain_type = typename Impl::SuperLUVectorChooser<M>::domain_type

The type of the domain of the solver.

## Matrix

template<typename M>

using Dune::SuperLU< M >::Matrix = M

The matrix type.

## matrix_type

template<typename M>

using Dune::SuperLU< M >::matrix_type = M

## MatrixInitializer

template<typename M>

typedef SuperMatrixInitializer<Matrix> Dune::SuperLU< M >::MatrixInitializer

Type of an associated initializer class.

## range_type

template<typename M>

using Dune::SuperLU< M >::range_type = typename Impl::SuperLUVectorChooser<M>::range_type

The type of the range of the solver.

## SuperLUMatrix

template<typename M>

typedef Dune::SuperLUMatrix<Matrix> Dune::SuperLU< M >::SuperLUMatrix

The corresponding SuperLU Matrix type.

## Constructor & Destructor Documentation

## SuperLU()

template<typename M>

Dune::SuperLU< M >::SuperLU | ( | const Matrix & | matrix,
|  | const ParameterTree & | config )

inline

Constructs the SuperLU solver.

Parameters

  matrix | The matrix of the system to solve.
  config | ParameterTree containing solver parameters.

ParameterTree Key | Meaning
--- | ---
verbose | The verbosity level. default=false
reuseVector | Reuse initially allocated vectors in apply. default=true

## Member Function Documentation

## apply()

template<typename M>

void Dune::SuperLU< M >::apply | ( | domain_type & | x,
|  | range_type & | b,
|  | double | reduction,
|  | InverseOperatorResult & | res )

inline override

apply inverse operator, with given convergence criteria.

Warning
  Right hand side b may be overwritten!

Parameters

  x | The left hand side to store the result in.
  b | The right hand side
  reduction | The minimum defect reduction to achieve.
  res | Object to store the statistics about applying the operator.

Exceptions

  SolverAbort | When the solver detects a problem and cannot continue

## category()

template<typename M>

SolverCategory::Category Dune::SuperLU< M >::category | ( |  | ) | const

inline override

Category of the solver (see SolverCategory::Category).

## name()

template<typename M>

const char * Dune::SuperLU< M >::name | ( |  | ) |

inline

## nnz()

template<typename M>

SuperLUMatrix::size_type Dune::SuperLU< M >::nnz | ( |  | ) | const

inline

## Friends And Related Symbol Documentation

## SeqOverlappingSchwarz

template<typename M>
template<class Mat, class X, class TM, class TD, class T1>

friend class SeqOverlappingSchwarz

friend

## SeqOverlappingSchwarzAssemblerHelper< SuperLU< Matrix >, true >

template<typename M>

friend struct SeqOverlappingSchwarzAssemblerHelper< SuperLU< Matrix >, true >

friend

The documentation for this class was generated from the following file:

- superlu.hh